package org.jboss.as.integration.hornetq.deployers.pojo;

import org.hornetq.jms.server.JMSServerManager;
import org.jboss.as.integration.hornetq.deployers.HornetQJMSRealDeployer;
import org.jboss.logging.Logger;

/**
 * 
 * Objects of this class are created by the MicroContainer through
 * BeanMetadataClass at {@link HornetQJMSRealDeployer}
 * 
 * @see HornetQJMSRealDeployer
 * */
public abstract class HornetQJMSDeployment<T> extends AbstractHornetQControlReferenceDeployment
{

   private static final Logger log = Logger.getLogger(HornetQJMSDeployment.class);

   protected JMSServerManager jmsServer;

   protected String name;
   
   protected T config;
   
   public T getConfig()
   {
      return config;
   }
   
   public void setConfig(T config)
   {
      this.config = config;
   }

   public JMSServerManager getJmsServer()
   {
      return jmsServer;
   }

   public void setJmsServer(JMSServerManager jmsServer)
   {
      this.jmsServer = jmsServer;
   }

   public void setName(String name)
   {
      this.name = name;
   }

   public String getName()
   {
      return name;
   }

   public abstract void start() throws Exception;

   public abstract void stop() throws Exception;

}
