package org.jboss.as.integration.hornetq.deployers.pojo;

import org.hornetq.api.core.management.ObjectNameBuilder;
import org.hornetq.jms.server.config.JMSQueueConfiguration;
import org.jboss.logging.Logger;

import javax.management.ObjectName;

public class HornetQQueueDeployment extends HornetQJMSDeployment<JMSQueueConfiguration>
{
   private static final Logger log = Logger.getLogger(HornetQQueueDeployment.class);

   @Override
   public void start() throws Exception
   {
      try
      {
         
         log.info("Deploying Queue " + config.getName());
         jmsServer.createQueue(false, config.getName(), config.getSelector(), config.isDurable(), config.getBindings());
         
         // Register the Control MBean in MC
         registerControlReference(ObjectNameBuilder.DEFAULT.getJMSQueueObjectName(config.getName()));
         
      } catch (Exception e)
      {
         log.warn("Error deploying Queue: " + config.getName(), e);
         throw e;
      }
   }

   @Override
   public void stop() throws Exception
   {
      log.info("Undeploying queue " + config.getName());
      
      unregisterControlReference(ObjectNameBuilder.DEFAULT.getJMSQueueObjectName(config.getName()));
      
      jmsServer.removeQueueFromJNDI(config.getName());
      
   }

}
